--::::::::::
--hashfcns.spc
--::::::::::
-- *********************************************************
-- *                                                       *
-- *  Hashing_Functions_PKG                                *  SPEC
-- *                                                       *
-- *********************************************************
package Hashing_Functions_PKG is
--| Purpose
--| Provide a string hashing function.
--|
--| Initialization Exceptions (none)
--| Notes (none)
--|
--| Modifications
--| Author: Bill Toscano and Michael Gordon, Intermetrics

  generic
    Prime_Num: in POSITIVE;  -- Required to be prime
  function Hash_String (S: STRING) return NATURAL;
  --| Purpose
  --| Produces a uniform distribution over the range 0..prime - 1.
  --|
  --| Exceptions (none)
  --| Notes (none)
    
end Hashing_Functions_PKG;
