--::::::::::
--permutat.spc
--::::::::::
-- ****************************************************
-- *                                                  *
-- *  Permutations_Class                              *  SPEC
-- *                                                  *
-- ****************************************************
generic
  type ITEM_TYPE  is private;
  type INDEX_TYPE is (<>);
  type LIST_TYPE  is array (INDEX_TYPE range <>) of ITEM_TYPE;
package Permutations_Class is
--| Purpose
--| Generate all permutations of a set of ITEM_TYPE objects.
--|
--| Initialization Exceptions (none)
--| Notes (none)
--|
--| Modifications
--| Author: Doug Bryan, Stanford University

  -- ........................................................
  -- .                                                      .
  -- .  Permutations_Class.Iterate_Through_Length...        .  SPEC
  -- .                                                      .
  -- ........................................................
  generic
    with procedure Process (A_Permutation : LIST_TYPE);
  procedure Iterate_Through_Length_Factorial_Permutations
    (Of_Items : LIST_TYPE);
  --| Purpose
  --| For an actual parameter for Of_Items of length n,
  --| n! (n factorial) permutations will be produced.
  --|
  --| The procedure permutes the elements in the array ITEMS.
  --| actually it permutes their indicies and re-arranges the items
  --| within the list.  The procedure does not care of any or all
  --| of the items in the list are equal (the same).
  --|
  --| Exceptions (none)
  --| Notes (none)

end Permutations_Class;
