-------- SIMTEL20 Ada Software Repository Prologue ------------
-- Unit name    : Generic_B_Plus_Tree (BPLUSTREE)
-- Version      : 1.0.0 
-- Author       : William Thomas Wolfe  (USA SSN 262-61-7093), 
--              : for the Clemson Ada Software Repository
--              : Department of Computer Science, Clemson University 
--              : Clemson, SC  29634-1906   (1-803-654-3444)
-- DDN Address  : cpscada@citron.cs.clemson.edu, 
--              : or ...!gatech!hubcap!citron!cpscada 
-- Copyright    : (c) Clemson University (ACM-style copyright)
-- Date created : 1988 12 ??    -- best guess... 
-- Release date : 1989 09 03 
-- Last update  : 1989 09 03 
-- Machine/System Compiled/Run on : Telesoft TeleGen2 / Sun-3
---------------------------------------------------------------
-- Keywords     : Generic B+ Tree 
--
-- Abstract     : A tree structure which permits one to store an 
--                arbitrary set of keys, and some arbitrary set of
--                non-key items which are associated with a given key.
--                The user must supply the type of key to be used,
--                the type of non-key item, and a container for the
--                non-key items.  The container is typically a linked
--                list, but can be practically any data structure desired.
--
--                Once items have been stored, it is possible to randomly
--                and sequentially access items via their associated keys;
--                sequential access is permitted in either direction.  The
--                structure is implemented in such a way as to make repeated
--                accesses to the same key item very fast; this applies, 
--                for example, to operations such as Get_Preceding_Key and
--                Get_Following_Key in which the specified key happens 
--                to be the key referenced in the preceding operation.
--
--                This implementation is for sequential use only, but
--                can be readily modified as per Booch (Software 
--                Components With Ada, pages 203-205) if instances of 
--                the B_Plus_Tree are to be shared by several tasks.
--
----------------------------- Revision history -----------------------------
--
--    DATE       VERSION         AUTHOR                NOTES 
-- ==========    =======   ====================     ===============
-- 1989 09 03     1.0.0    William Thomas Wolfe     Released to ASR
--
-------------------------- Distribution and Copyright ---------------------
--
--  *************************************************************************************
--  **  This software is part of the Clemson University Computer Science Department's  **
--  **  Ada Software Repository, and is copyrighted (C) 1989 by Clemson University.    **
--  **  Permission to copy without fee all or part of this software is granted,        **
--  **  provided that the copies are not made or distributed for direct commercial     **
--  **  advantage, and that this copyright notice is not deleted or modified.  To      **
--  **  copy otherwise, or to republish, requires a fee and/or specific permission.    **
--  **  >> All bug reporters receive a free updated copy once the bug's corrected! <<  ** 
--  **  E-mail to: cpscada@citron.cs.clemson.edu or ...!gatech!hubcap!citron!cpscada.  **
--  *************************************************************************************
--
------------------ Disclaimer ---------------------------------
--
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--
-------------------END-PROLOGUE--------------------------------

