with Date_Declaration_Template, Date_Conversion_Template;

package Dbms_Date is

   type Month is new Integer range 1 .. 12;
   type Year  is new Integer range 0 .. 2050;

   package Date_Declaration is new Date_Declaration_Template
       (Month => Month, Year_Range => Year);

   subtype Day is Date_Declaration.Day;

   package Date_Conversion is new Date_Conversion_Template
       (Month => Month,
        Day   => Day,
        Year  => Year,
        Date  => Long_Integer);

end Dbms_Date;
