package Dbms_Declarations is

   Maximum_Fields              : constant := 255;
   Maximum_Alphanumeric_Length : constant := 255;

   type Dbms_Field_Count is  range 1 .. Maximum_Fields;
   type Index_Id is  range 0 .. Maximum_Fields;

   type Alphanumeric_Length is
       range 1 .. Maximum_Alphanumeric_Length;

   type Fields is (Alphanumeric, Date, Real, Currency, Long, Short);

   type Field_Kind (Kind : Fields) is
      record
         case Kind is
            when Alphanumeric =>
               Length : Alphanumeric_Length;
            when others =>
               null;
         end case;
      end record;

   type Index_Kind is
      (Primary,
       Unmaintained_Secondary,
       Maintained_Secondary);

   type Search_Kind is (First, Next, Closest);

   type Open_Options is
      record
         Save_Every_Change : Boolean;
         Id                : Index_Id;
      end record;

end Dbms_Declarations;
