package Dbms_Errors is

   type Error_Kind is
      (Successful,
       Drive_Not_Ready,
       Directory_Not_Found,
       File_Is_Busy,
       File_Is_Locked,
       File_Not_Found,
       Corrupted_Table,
       Corrupted_Primary_Index,
       Primary_Index_Out_Of_Date,
       Record_Locked,
       Directory_Busy,
       Directory_Locked,
       No_Directory_Access,
       Incorrect_Sort_Version,
       Directory_Not_Private,
       Multiple_Net_Files,
       Insufficient_Password_Rights,
       Table_Is_Write_Protected,
       Type_Mismatch,
       Argument_Out_Of_Range,
       Invalid_Argument,
       Insufficient_Memory,
       Insufficient_Disk_Space,
       Current_Record_Deleted,
       Insufficient_File_Handles,
       Insufficient_Table_Handles,
       Invalid_Date,
       Invalid_Field_Name,
       Invalid_Field_Handle,
       Invalid_Table_Handle,
       Initialization_Failure,
       Invalid_Engine_State,
       Different_Table_Structures,
       Already_Initialized,
       Table_Open,
       No_More_Temporary_Names,
       Record_Not_Found,
       Table_Is_Indexed,
       Table_Is_Not_Indexed,
       Secondary_Index_Out_Of_Date,
       Key_Violation,
       Login_Prohibited,
       Invalid_Table_Name,
       End_Of_Table,
       Start_Of_Table,
       Insufficient_Record_Handles,
       Invalid_Record_Handle,
       Empty_Table,
       Invalid_Lock_Code,
       Network_Initialization_Failure,
       Invalid_File_Name,
       Invalid_Unlock,
       Invalid_Lock_Handle,
       Table_Lock_Maximum_Reached,
       Invalid_Sort_Order_Table,
       Invalid_Net_Type,
       Invalid_Directory_Name,
       Too_Many_Passwords_Specified,
       Invalid_Password,
       Buffer_Too_Small,
       Table_Is_Busy,
       Table_Is_Locked,
       Table_Not_Found,
       Secondary_Index_Not_Found,
       Corrupted_Secondary_Index,
       Secondary_Index_Open,
       Disk_Write_Protected,
       Record_Too_Big_For_Index,
       General_Hardware_Failure,
       Stack_Crash,
       Table_Is_Full,
       Insufficient_Swap_Space);


private

   for Error_Kind use
      (Successful                     => 0,
       Drive_Not_Ready                => 1,
       Directory_Not_Found            => 2,
       File_Is_Busy                   => 3,
       File_Is_Locked                 => 4,
       File_Not_Found                 => 5,
       Corrupted_Table                => 6,
       Corrupted_Primary_Index        => 7,
       Primary_Index_Out_Of_Date      => 8,
       Record_Locked                  => 9,
       Directory_Busy                 => 10,
       Directory_Locked               => 11,
       No_Directory_Access            => 12,
       Incorrect_Sort_Version         => 13,
       Directory_Not_Private          => 14,
       Multiple_Net_Files             => 15,
       Insufficient_Password_Rights   => 21,
       Table_Is_Write_Protected       => 22,
       Type_Mismatch                  => 30,
       Argument_Out_Of_Range          => 31,
       Invalid_Argument               => 33,
       Insufficient_Memory            => 40,
       Insufficient_Disk_Space        => 41,
       Current_Record_Deleted         => 50,
       Insufficient_File_Handles      => 70,
       Insufficient_Table_Handles     => 72,
       Invalid_Date                   => 73,
       Invalid_Field_Name             => 74,
       Invalid_Field_Handle           => 75,
       Invalid_Table_Handle           => 76,
       Initialization_Failure         => 78,
       Invalid_Engine_State           => 79,
       Different_Table_Structures     => 81,
       Already_Initialized            => 82,
       Table_Open                     => 83,
       No_More_Temporary_Names        => 86,
       Record_Not_Found               => 89,
       Table_Is_Indexed               => 94,
       Table_Is_Not_Indexed           => 95,
       Secondary_Index_Out_Of_Date    => 96,
       Key_Violation                  => 97,
       Login_Prohibited               => 98,
       Invalid_Table_Name             => 99,
       End_Of_Table                   => 101,
       Start_Of_Table                 => 102,
       Insufficient_Record_Handles    => 103,
       Invalid_Record_Handle          => 104,
       Empty_Table                    => 105,
       Invalid_Lock_Code              => 106,
       Network_Initialization_Failure => 107,
       Invalid_File_Name              => 108,
       Invalid_Unlock                 => 109,
       Invalid_Lock_Handle            => 110,
       Table_Lock_Maximum_Reached     => 111,
       Invalid_Sort_Order_Table       => 112,
       Invalid_Net_Type               => 113,
       Invalid_Directory_Name         => 114,
       Too_Many_Passwords_Specified   => 115,
       Invalid_Password               => 116,
       Buffer_Too_Small               => 117,
       Table_Is_Busy                  => 118,
       Table_Is_Locked                => 119,
       Table_Not_Found                => 120,
       Secondary_Index_Not_Found      => 121,
       Corrupted_Secondary_Index      => 122,
       Secondary_Index_Open           => 123,
       Disk_Write_Protected           => 124,
       Record_Too_Big_For_Index       => 125,
       General_Hardware_Failure       => 126,
       Stack_Crash                    => 127,
       Table_Is_Full                  => 128,
       Insufficient_Swap_Space        => 129);

end Dbms_Errors;
