with Dbms, Parts_Inventory_Database, Dbms_Date, Transaction_Template;

procedure Data_Import is

   Transaction_Length : Positive := 30;
   subtype Transaction is String (1 .. Transaction_Length);

   function Is_Data_Record
       (T : in Transaction) return
         Parts_Inventory_Database.Data_Record_Description;

   package Transaction_File is new Transaction_Template
       (Transaction => Parts_Inventory_Database.Data_Record_Description,
        Length => Transaction_Length,
        Convert_To_Transaction => Is_Data_Record);

   function Is_Data_Record
       (T : in Transaction) return
         Parts_Inventory_Database.Data_Record_Description is
      Temp : Parts_Inventory_Database.Data_Record_Description;
      use Dbms_Date, Date_Declaration, Parts_Inventory_Database;
   begin
      Temp.The_Part_Number     := Part_Number (T (1 .. 8));
      Temp.The_Customer_Number := Customer_Number (T (10 .. 17));
      Temp.The_Quantity        := Quantity'VALUE (T (19 .. 21));
      Temp.The_Date.The_Month  := Month'VALUE (T (23 .. 24));
      Temp.The_Date.The_Day    := Date_Declaration.Day'VALUE (T (26 .. 27));
      Temp.The_Date.The_Year   := Year'VALUE (T (29 .. 30));
      return Temp;
   end Is_Data_Record;

begin

   Dbms.Impart;

   Transaction_File.Open ("IMPORT.DAT");
   Parts_Inventory_Database.Open;

Main_Loop:

   loop
      exit Main_Loop when Transaction_File.Is_At_End_Of_File;
      Parts_Inventory_Database.Append
         (Using => Transaction_File.Is_Next_Transaction);
   end loop Main_Loop;

   Parts_Inventory_Database.Close;
   Transaction_File.Close;

   Dbms.Depart;

end Data_Import;
